<?php

namespace Drupal\integration_chargebee\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Config\ConfigFactory;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * An Checkout controller.
 */
class CheckoutController extends ControllerBase {

  /**
   * @var \Drupal\Core\Config\ConfigFactory
   */
  protected $ConfigFactory;

  /**
   *
   */
  public function __construct(ConfigFactory $configFactory) {
    $this->configFactory = $configFactory;
  }

  /**
   *
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('config.factory'),

    );
  }

  /**
   * Returns a Plan data.
   */
  public function plan() {

    $plan_config = $this->configFactory->getEditable('integration_chargebee.plan');
    $config = $this->configFactory->getEditable('integration_chargebee.settings');
    $plan = $plan_config->get();
    $items = array();
    foreach ($plan as $key => $value) {

      $items[] =array(
        'status' => $config->get('integration_chargebee_api_'.$value.'_status'),
        'name' => $config->get('integration_chargebee_api_'.$value.'_title'),
        'id' => $config->get('integration_chargebee_api_'.$value),
        'amount' => $config->get('integration_chargebee_api_'.$value.'_amount'),
        'description' => $config->get('integration_chargebee_api_'.$value.'_details'));
    }

    $build['page'] = [
      '#theme' => 'plan_list',
      '#items' => $items,
    ];
    $build['#cache']['max-age'] = 0;
    $build['#attached']['library'][] = 'integration_chargebee/integration_chargebee_style';
    return [
      '#type' => '#markup',
      '#markup' => \Drupal::service('renderer')->render($build),
    ];

  }

}
