<?php

namespace Drupal\integration_chargebee\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;
use ChargeBee\ChargeBee\Environment;
use ChargeBee\ChargeBee\Models\Customer;
use ChargeBee\ChargeBee\Models\PaymentSource;
use ChargeBee\ChargeBee\Models\Subscription;
use ChargeBee\ChargeBee\Models\Invoice;
/**
 * Class SubscriptionForm.
 *
 * @package Drupal\xai\Form
 */
class SubscriptionForm extends ConfigFormBase
{

    /**
     * {@inheritdoc}
     */
    protected function getEditableConfigNames()
    {
        return [
            'subscriptionform.settings',
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function getFormId()
    {
        return 'subscriptionform';
    }

    /**
     * {@inheritdoc}
     */
    public function buildForm(array $form, FormStateInterface $form_state)
    {



         $form['first_name'] = array(
            '#type' => 'textfield',
            '#title' => t('First Name'),
            '#default_value' => ''
            );

        $form['last_name'] = array(
            '#type' => 'textfield',
            '#title' => t('Last Name'),
            '#default_value' => ''
            );
        $form['email'] = array(
            '#type' => 'textfield',
            '#title' => t('Email'),
            '#default_value' => '',
            );
        $form['billingAddress'] = array(
            '#type' => 'details',
            '#title' => t('Billing Address'),
            );
        $form['billingAddress']['line1'] = array(
            '#type' => 'textfield',
            '#title' => t('Address line 1'),
            '#default_value' => ''
            );

        $form['billingAddress']['city'] = array(
            '#type' => 'textfield',
            '#title' => t('City'),
            '#default_value' => ''
            );
        $form['billingAddress']['state'] = array(
            '#type' => 'textfield',
            '#title' => t('State'),
            '#default_value' => ''
            );
        $form['billingAddress']['country'] = array(
            '#type' => 'textfield',
            '#title' => t('Country'),
            '#default_value' => ''
            );
        $form['billingAddress']['zip'] = array(
            '#type' => 'textfield',
            '#title' => t('zip'),
            '#default_value' => ''
            );
        $form['payment_details'] = array(
            '#type' => 'details',
            '#title' => t('Payment Information'),
            );
        return parent::buildForm($form, $form_state);
    }

    /**
     * {@inheritdoc}
     */
    public function validateForm(array &$form, FormStateInterface $form_state)
    {
        parent::validateForm($form, $form_state);
    }

    /**
     * {@inheritdoc}
     */
    public function submitForm(array &$form, FormStateInterface $form_state)
    {
        $config = \Drupal::config('integration_chargebee.settings');

        $site_name = $config->get('integration_chargebee_api_site_name');
        $site_api_key = $config->get('integration_chargebee_api_key');
        Environment::configure("$site_name","$site_api_key");
        // Add customer on integration_chargebee.
        $result = Customer::create(array(
            "firstName" => $form_state->getValue('first_name'),
            "lastName" => $form_state->getValue('last_name'),
            "email" => $form_state->getValue('email'),
            "billingAddress" => array(
              "firstName" => $form_state->getValue('first_name'),
              "lastName" => $form_state->getValue('last_name'),
              "line1" => $form_state->getValue('line1'),
              "city" => $form_state->getValue('city'),
              "state" => $form_state->getValue('state'),
              "zip" => $form_state->getValue('zip'),
              "country" =>$form_state->getValue('country')
              )
        ));

        $customer = $result->customer();
        $customer_id = $customer->id;
        // Added the card
        $result = PaymentSource::createCard(array(
            "customerId" => $customer_id,
            "card" => array(
                "number" => "378282246310005",
                "cvv" => "100",
                "expiryYear" => 2022,
                "expiryMonth" => 12
                )
            ));

        // Subscribe the plan
        $result = Subscription::createWithItems("$customer_id",array(
            'invoiceImmediately' => true,
            'termsToCharge' => 1,
            "subscriptionItems" => array(array(
                "itemPriceId" => "testbt-INR-Monthly",
                "unitPrice" => 10000),
            )
            ));
        $subscription = $result->subscription();
        $invoice = $result->invoice();
        kint($subscription);
        kint($invoice);
die;
    }
}
