<?php

namespace Drupal\integration_chargebee\Services;

use Drupal\user\Entity\User;
use Drupal\Core\Database\Connection;
use Drupal\Core\Messenger\MessengerInterface;
use Drupal\Core\Logger\LoggerChannelFactoryInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Entity\EntityTypeManagerInterface;
use ChargeBee\ChargeBee\Environment;
use ChargeBee\ChargeBee\Models\Subscription;
use ChargeBee\ChargeBee\Models\Transaction;


/**
 *  ChargebeeService Service class
 */
class ChargebeeService {

 /**
   * Account Information
   *
   * @var \Drupal\Core\Session\AccountInterface
   */
  protected $currentUser;

   /**
   * Entity manager.
   *
   * @var \Drupal\Core\Entity\EntityTypeManagerInterface
   */
  protected $entityTypeManager;

  /**
   * Database connection.
   *
   * @var \Drupal\Core\Database\Connection
   */
  protected $connection;

  /**
   * The Messenger service.
   *
   * @var \Drupal\Core\Messenger\MessengerInterface
   */
  protected $messenger;

   /**
   * Logger.
   *
   * @var \Drupal\Core\Logger\LoggerChannelFactoryInterface
   */
  protected $loggerFactory;


  /**
   * integration_chargebee Service constructor.
   *
   * @param Drupal\Core\Session\AccountInterface $currentUser
   *  Account Interface.
   * @param \Drupal\Core\Entity\EntityTypeManagerInterface $entity_type_manager
   *   Entity Type Manager.
   * @param \Drupal\Core\Database\Connection $connection
   *  Connection Interface.
   * @param \Drupal\Core\Messenger\MessengerInterface $messenger
   *   The messenger service.
   * @param \Drupal\Core\Logger\LoggerChannelFactoryInterface $loggerFactory
   *  Logger.
   */
  public function __construct(AccountInterface $current_user,
  EntityTypeManagerInterface $entity_type_manager,
  Connection $connection,
  MessengerInterface $messenger,
  LoggerChannelFactoryInterface $loggerFactory,
  ) {
  $this->currentUser = $current_user;
  $this->entityTypeManager = $entity_type_manager;
  $this->connection = $connection;
  $this->messenger = $messenger;
  $this->loggerFactory = $loggerFactory;



  }

  /**
   * Implement the getProtectedValue.
   */
  public function getProtectedValue($obj, $name) {
    $array = (array) $obj;
    $prefix = chr(0) . '*' . chr(0);
    return $array[$prefix . $name];
  }

  /**
   * Implements the getSubscriptionDetails.
   */
  public function getSubscriptionDetails($subscription_id) {
    // TO DO
  }

  }
